#include "MainMenuScene.h"
#include "GameScene.h"
#include "Definitions.h"
#include "cocostudio/CocoStudio.h"
#include "ui/CocosGUI.h"
#include "SimpleAudioEngine.h"

USING_NS_CC;

using namespace cocostudio::timeline;
using namespace CocosDenshion;

Scene* MainMenuScene::createScene()
{
    // 'scene' is an autorelease object
    auto scene = Scene::create();
    
    // 'layer' is an autorelease object
    auto layer = MainMenuScene::create();

    // add layer as a child to scene
    scene->addChild(layer);

    // return the scene
    return scene;
}

// on "init" you need to initialize your instance
bool MainMenuScene::init()
{
    if ( !Layer::init() )
    {
        return false;
    }
    
	Size visibleSize = Director::getInstance()->getVisibleSize();
	Vec2 origin = Director::getInstance()->getVisibleOrigin();

	auto background = Sprite::create("menu.png");
	background->setPosition(Point(visibleSize.width / 2 + origin.x, visibleSize.height / 2 + origin.y));

	this->addChild(background);

	//preload the click effect
	auto audio = SimpleAudioEngine::getInstance();
	audio->preloadEffect("click.wav");

	//Snippet 2-0
	auto playButton = MenuItemImage::create("play.png", "play_clicked.png", CC_CALLBACK_1(MainMenuScene::goToGameScene, this));
	playButton->setPosition(Point(visibleSize.width / 2 + origin.x, visibleSize.height / 2 + origin.y));

	auto menu = Menu::create(playButton, NULL);
	menu->setPosition(Point::ZERO);

	this->addChild(menu);


	return true;
}

void MainMenuScene::goToGameScene(cocos2d::Ref *sender) {
	//play click effect
	auto audio = SimpleAudioEngine::getInstance();
	audio->playEffect("click.wav");


	auto scene = GameScene::createScene();

	Director::getInstance()->replaceScene(scene);
}
